/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package xquerydemo;

import java.io.File;
import javax.xml.transform.stream.StreamSource;
import net.sf.saxon.Configuration;
import net.sf.saxon.query.DynamicQueryContext;
import net.sf.saxon.query.StaticQueryContext;
import net.sf.saxon.query.XQueryExpression;
import net.sf.saxon.tinytree.TinyTextImpl;
import net.sf.saxon.trans.XPathException;

/**
 *
 * @author tomp
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws XPathException {
        Configuration config = new Configuration();
        StaticQueryContext staticContext = new StaticQueryContext(config);

        XQueryExpression exp =
                staticContext.compileQuery("for $person in doc('addressbook.xml')/addressbook/person where $person/lastname='Polák' return $person/date-of-birth/text()");

        DynamicQueryContext dynamicContext =
                new DynamicQueryContext(config);
        dynamicContext.setContextItem(
                config.buildDocument(
                new StreamSource(new File("addressbook.xml"))));
        
        // TinyTreeImpl must be unfortunately used even if it is a Saxon-specific class...
        String dateOfBirth = ((TinyTextImpl)exp.evaluateSingle(dynamicContext)).getStringValue();
        
        System.out.println("The person of name Polák is born on " + dateOfBirth + ".");

    }
}
